/**
 * Created by a0389339 on 7/21/2014.
 */

var SerialPort = require("serialport");
var ws = require( 'ws' );
var WebSocketServer = ws.Server;
var logger = require('./logger.js');

var serial = {};

// list serial ports
serial.list = function ( output, data ) {

    var input = {
        data : function( inputData ) {
            SerialPort.list(function (err, ports) {
                if( err ) {
                    output.error( err.toString() );
                } else {
                    output.success( ports );
                }
            });
        }
    };

    // start things off
    input.data( data );

    return input;
};


// open a serial port
// data = { comName - comport to open, baudrate - baudrate of the serial connection }
serial.open = function ( output , data ) {

   // create the serial port
    var serialPort = new SerialPort.SerialPort( data.comName, data, function ( err ) {

        if ( err ) {
            var msg = data.comName + " could not be opened : " + err.toString();
            logger.info( msg );
            output.error( msg );
        } else {
            serialPort.on("close", function () {
                logger.info("Serial port connection closed: " + data.comName);
            });

            serialPort.on("open", function () {
                logger.info("Serial port connection opened: " + data.comName);
            });

            serialPort.on("data", function (data) {
                output.serialText( data.toString() );
            });

            serialPort.on("error", function( data )  {
                logger.info("serial port error");
                output.text( data.toString() );
            });

            logger.info( data.comName + " opened" );
            output.success( data.comName + " opened" );
        }
    });

    // create a stream to handle input
    var input = {
        data :  function ( dataToWrite ) {
                    serialPort.write( dataToWrite, function ( err, results ) {
                    if ( err ) {
                        var msg = "Serial Write Failed: " + err.toString()
                        logger.info(msg);
                        ouput.text(msg);
                    }
           });
         },
        close : function() {
            try {
                serialPort.close();
            } catch ( err ) {
                logger.info( "Could not close serial port: " + err.toString() );
            }
        }
    };

    return input;
};


module.exports = serial;